///////////////////
// ged child report 
// by Michael Gibson
// copyright 2007
// tested against Ftree, EasyTree, and others
// Release under the GPL

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "GDXlib.h"

char *r_version="0.6.1";

void print_report(void);

char filename[50];           // file to be read in 
char personoi[9];            // person of interest [mother or father]

char last_action[5];
char last_surname[110];
char indi[6];
char indi_fams[9999][110];
char indi_name[9999][110];
char indi_surname[9999][110];
char disp_surname[9999][110];
char indi_sex[9999];
char seximage[9999][110];
char indi_birt_date[9999][110];
char indi_deat_date[9999][110];
int indi_r=0;
char fam[6];
char fam_husb[1900][110];
char fam_wife[1900][110];
char fam_chil[1900][110];
char fam_marr_date[1900][110];
char fam_div_date[1900][110];
int fam_r=0;
int id_pointer=0;
int fam_flag_id_pointer=0;
int x=0, y=0;
char temp[80];
FILE *fp;
int print_family=0;
int family_recorded=0;
int label0[20];
int label_inc=1;
int lastchild=0;

/////////////////////////////////////////////////////
///// quit app
/////////////////////////////////////////////////////
static void destroy(void)
{
    gdx_closewindow();
}
///////////////////////////////////////////////////
//help
///////////////////////////////////////////////////
static void help(void)
{
 x_imgbox("images/helptext.xpm","Help");
}
//////////////////////////////////////////////////
//// addchild
//////////////////////////////////////////////////
static void addchild(void)
{
  char systemstring[150];

  sprintf(systemstring,"./gedadd_child %d %s %d &",fam_flag_id_pointer,filename,lastchild);
  system(systemstring);
  gdx_closewindow();
}

////////////////////////////////////////////////////
/// int main()
/////////////////////////////////////////////////
int main(int argc, char **argv)
{

  int button_01,button_02,button_03;

  x_open();
  gdx_window("GEDCOM Family View",600,400);
  gdx_setwindowbg("images/white.xpm",1);

  gdx_image(1,1,"images/bbbg.xpm");
  button_01 = gdx_imagebutton(5,25,"images/close.xpm",destroy);
  button_02 = gdx_imagebutton(5,50,"images/addchild.xpm",addchild);
  button_03 = gdx_imagebutton(5,100,"images/help.xpm",help);

  if(argc==3){
    sprintf(personoi,"%s",argv[1]);
    sprintf(filename,"%s",argv[2]);
    printf("Person of Interest ID =%s from filename %s\n",personoi,filename);
  }

  if((fp=fopen(filename,"r"))==NULL ){
     printf("GEDCOM Report: Sorry, no file found. \n");
     exit(0);
  }

  print_report();

 if(family_recorded==0){
    x_imgbox("images/fsorry.xpm","sorry");
    exit(0);
  }
  else{
    for(x=1;x<=label_inc;x++)gdx_setlabelbg("images/white.xpm",1,label0[x]);
  }
    gdx_main();

  x_close();

  return(0);
}


//////////////////////////////////////////
/// print_report()
/////////////////////////////////////////
void print_report()
{
int loop;
int label_y_inc=25;
char label_out[100];

///// Catches 
///// 0 INDI -> 1 NAME 
///// and 
///// 0 SUBM -> 1 NAME
for(loop=0;loop<99999;loop++){

  strcpy(temp,"123456789012345678901234567890123456789012345678901234567890123456789012345678");
  fgets(temp,80,fp);
 // printf("%s",temp);
  if(temp[0]=='1' && temp[2]=='N' && temp[3]=='A'){     ///1 NAME
     for(x=7;x<75;x++){
       if(temp[x]=='\r') temp[x]='\0';
       if(temp[x]=='\n') temp[x]='\0';
       temp[x-7]=temp[x];
     } 
     strcpy(indi_name[indi_r],temp);
     //printf("**found individual %s\n",indi_name[indi_r]);
  }

// 0123456789012
// 1 FAMS @F0469@
  if(temp[0]=='1' && temp[2]=='F' && temp[3]=='A' && temp[5]=='S'){ 
      sprintf(indi_fams[indi_r],"%c%c%c%c",temp[9],temp[10],temp[11],temp[12]);
      //printf("found parent %d of family %s\n", indi_r,indi_fams[indi_r]);
      if(atoi(personoi) == indi_r){
        fam_flag_id_pointer=atoi(indi_fams[indi_r]);
        //printf("family to print: %d\n",fam_flag_id_pointer);
      }
  }

///// Catches
///// 0 FAM -> 1 HUSB
  if(temp[0]=='1' && temp[2]=='H' && temp[3]=='U'){   ///1 HUSB
      for(x=8;x<75;x++){
         if(temp[x]=='@' ||temp[x]=='I') temp[x]=' ';}
      sprintf(fam_husb[fam_r],"%c%c%c%c",temp[9],temp[10],temp[11],temp[12]);
      id_pointer=atoi(fam_husb[fam_r]);
      if(print_family==1){
        sprintf(label_out,"Father = %s (%s - %s)",indi_name[id_pointer],indi_birt_date[id_pointer],indi_deat_date[id_pointer]);
        label0[label_inc]=gdx_label(label_out,66,label_y_inc,1);
        label_y_inc=label_y_inc + 30;
        label_inc++;
      }
  }

///// Catches
///// 0 FAM -> 1 WIFE
  if(temp[0]=='1' && temp[2]=='W' && temp[3]=='I'){ //1 WIFE
      for(x=8;x<75;x++){
         if(temp[x]=='@' ||temp[x]=='I') temp[x]=' ';}
      sprintf(fam_wife[fam_r],"%c%c%c%c",temp[9],temp[10],temp[11],temp[12]);
      id_pointer=atoi(fam_wife[fam_r]);
      if(print_family==1){
        sprintf(label_out,"Mother = %s (%s - %s)",indi_name[id_pointer],indi_birt_date[id_pointer],indi_deat_date[id_pointer]);
        label0[label_inc]=gdx_label(label_out,66,label_y_inc,1);
        label_y_inc=label_y_inc + 35;
        label_inc++;
      }
  }

///// Catches
///// 0 FAM -> 1 CHIL
  if(temp[0]=='1' && temp[2]=='C' && temp[3]=='H' && temp[4]=='I'){ //1 CHIL
      for(x=8;x<75;x++){
         if(temp[x]=='@' ||temp[x]=='I') temp[x]=' ';}
      sprintf(fam_chil[fam_r],"%c%c%c%c",temp[9],temp[10],temp[11],temp[12]);
      id_pointer=atoi(fam_chil[fam_r]);
      if(print_family==1){
        sprintf(label_out,"%s (%s - %s)",indi_name[id_pointer],indi_birt_date[id_pointer],indi_deat_date[id_pointer]);
        gdx_image(69,label_y_inc-26,seximage[id_pointer]);
        label0[label_inc]=gdx_label(label_out,160,label_y_inc,1);
        label_y_inc=label_y_inc + 30;
        label_inc++;
        lastchild=id_pointer;
      }
  }



//// Catches
//// 0 INDI -> 1 BIRT -> 2 DATE
//// 0 INDI -> 1 DEAT -> 2 DATE
//// 0 FAM  -> 1 MARR -> 2 DATE
//// 0 FAM  -> 1 DIV  -> 2 DATE
  if(temp[0]=='2' && temp[2]=='D' && temp[3]=='A'){ //2 DATE
     for(x=7;x<75;x++){
        if(temp[x]=='\n') temp[x]='\0';
        if(temp[x]=='\r') temp[x]='\0';
        temp[x-7]=temp[x];
        if(temp[x]=='\n') temp[x]='\0';
        if(temp[x]=='\r') temp[x]='\0';
     }
    // printf("*recorded a date\n");
     if(last_action[0]=='B' && last_action[1]=='I'){
      // printf("*recorded a birthdate\n");
       strcpy(indi_birt_date[indi_r],temp);
      // printf("*recorded a birthdate\n");
     }
     if(last_action[0]=='D' && last_action[1]=='E'){
       strcpy(indi_deat_date[indi_r],temp);
     }
     if(last_action[0]=='M' && last_action[1]=='A'){
       strcpy(fam_marr_date[fam_r],temp);
     }
      if(last_action[0]=='D' && last_action[1]=='I'){
       strcpy(fam_div_date[fam_r],temp);
     }
  }


  if(temp[0]=='1' && temp[2]=='S' && temp[3]=='E'){ //1 SEX
     indi_sex[indi_r]=temp[6];
     if(indi_sex[indi_r]=='M')strcpy(seximage[indi_r],"images/childlinem.xpm");
     if(indi_sex[indi_r]=='F')strcpy(seximage[indi_r],"images/childlinef.xpm");
  }

  if(temp[0]=='1' && temp[2]=='B' && temp[3]=='I'){ //1 BIRT
     strcpy(last_action,"BIRT");
    // printf("*about to record a birthdate\n");
  }    

  if(temp[0]=='1' && temp[2]=='D' && temp[3]=='E' && temp[4] =='A'){ //1 DEAT
     strcpy(last_action,"DEAT");
  }

  if(temp[0]=='1' && temp[2]=='B' && temp[3]=='U' && temp[4] =='R'){ //1 BURI
     strcpy(last_action,"BURI");
  }

  if(temp[0]=='1' && temp[2]=='C' && temp[3]=='R' && temp[4] =='E'){ //1 CREM
     strcpy(last_action,"CREM");
  }

  if(temp[0]=='1' && temp[2]=='M' && temp[3]=='A' && temp[4] =='R'){ //1 MARR
     strcpy(last_action,"MARR");
  }

  if(temp[0]=='1' && temp[2]=='D' && temp[3]=='I' && temp[4] =='V'){ //1 DIV 
     strcpy(last_action,"DIV");
  }


 if(temp[0]=='1' && temp[2]=='C' && temp[3]=='H' && temp[4] =='A'){ //1 CHAN 
    strcpy(last_action,"CHAN");
 }


  if(temp[0]=='0' && temp[2]=='@' && temp[3]=='I'){ //Individual 0 level start of record
      for(x=5;x<75;x++) if(temp[x]=='@' ||temp[x]=='I') temp[x]=' ';
      sprintf(indi,"%c%c%c%c",temp[4],temp[5],temp[6],temp[7]);
      indi_r=atoi(indi);
      //printf("*marked indi %d\n",indi_r);
  }

  if(temp[0]=='0' && temp[2]=='@' && temp[3]=='F'){ //Family 0 level start of record
      for(x=5;x<75;x++) if(temp[x]=='@' ||temp[x]=='F') temp[x]=' ';
      sprintf(fam,"%c%c%c%c",temp[4],temp[5],temp[6],temp[7]);
     // printf("Family Record = %s\n",fam);
      fam_r=atoi(fam);
      if(fam_r == fam_flag_id_pointer){
        family_recorded=1; 
        print_family=1;
      }
      else print_family=0;
  }

  if(temp[0] == '0' && temp[2] == 'T' && temp[3] == 'R') break;

}
		
fclose(fp);


}

